summaryrefslogtreecommitdiffstats
path: root/meta/recipes-support/libgpg-error/libgpg-error/0005-src-gen-lock-obj.sh-add-a-file.patch
blob: e6f6c09bac8f0656dd92dc7efd24ae9035628221 (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
From fcb414abb62223e66dba413d0ca86eab3ea5bbc3 Mon Sep 17 00:00:00 2001
From: Alexander Kanavin <alex.kanavin@gmail.com>
Date: Sun, 21 Jun 2020 13:54:47 +0000
Subject: [PATCH] src-gen-lock-obj.sh: add a file

This is erroneously missing from the tarball; it will show
up in the next release tarball, as upstream has fixed the
packaging in master.

Upstream-Status: Inappropriate
Signed-off-by: Alexander Kanavin <alex.kanavin@gmail.com>
---
 src/gen-lock-obj.sh | 112 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 112 insertions(+)
 create mode 100755 src/gen-lock-obj.sh

diff --git a/src/gen-lock-obj.sh b/src/gen-lock-obj.sh
new file mode 100755
index 0000000..13858cf
--- /dev/null
+++ b/src/gen-lock-obj.sh
@@ -0,0 +1,112 @@
+#! /bin/sh
+#
+# gen-lock-obj.sh - Build tool to construct the lock object.
+#
+# Copyright (C) 2020 g10 Code GmbH
+#
+# This file is part of libgpg-error.
+#
+# libgpg-error is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public License
+# as published by the Free Software Foundation; either version 2.1 of
+# the License, or (at your option) any later version.
+#
+# libgpg-error is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# Lesser General Public License for more details.
+#
+# You should have received a copy of the GNU Lesser General Public
+# License along with this program; if not, see <https://www.gnu.org/licenses/>.
+#
+
+#
+# Following variables should be defined to invoke this script
+#
+#   CC
+#   OBJDUMP
+#   AWK
+#   ac_ext
+#   ac_object
+#   host
+#   LOCK_ABI_VERSION
+#
+# An example:
+#
+# LOCK_ABI_VERSION=1 host=x86_64-pc-linux-gnu host_alias=x86_64-linux-gnu \
+#     CC=$host_alias-gcc OBJDUMP=$host_alias-objdump ac_ext=c ac_objext=o \
+#     AWK=gawk ./gen-lock-obj.sh
+#
+
+AWK_VERSION_OUTPUT=$($AWK 'BEGIN { print PROCINFO["version"] }')
+if test -n "$AWK_VERSION_OUTPUT"; then
+    # It's GNU awk, which supports PROCINFO.
+    AWK_OPTION=--non-decimal-data
+fi
+
+cat <<'EOF' >conftest.$ac_ext
+#include <pthread.h>
+pthread_mutex_t mtx = PTHREAD_MUTEX_INITIALIZER;
+EOF
+
+if $CC -c conftest.$ac_ext; then :
+  ac_mtx_size=$($OBJDUMP -j .bss -t conftest.$ac_objext \
+         | $AWK $AWK_OPTION '
+/mtx$/ { mtx_size = int("0x" $5) }
+END { print mtx_size }')
+else
+    echo "Can't determine mutex size"
+    exit 1
+fi
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+
+cat <<EOF
+## lock-obj-pub.$host.h
+## File created by gen-lock-obj.sh - DO NOT EDIT
+## To be included by mkheader into gpg-error.h
+
+typedef struct
+{
+  long _vers;
+  union {
+    volatile char _priv[$ac_mtx_size];
+    long _x_align;
+    long *_xp_align;
+  } u;
+} gpgrt_lock_t;
+
+EOF
+
+# FIXME: Support different alignment conditions of:
+#
+#     USE_16BYTE_ALIGNMENT
+#     USE_DOUBLE_FOR_ALIGNMENT
+#     USE_LONG_DOUBLE_FOR_ALIGNMENT
+#
+
+echo -n "#define GPGRT_LOCK_INITIALIZER {$LOCK_ABI_VERSION,{{"
+
+i=0
+while test "$i" -lt $ac_mtx_size; do
+    if test "$i" -ne 0 -a "$(( $i % 8 ))" -eq 0; then
+        echo ' \'
+        echo -n "                                    "
+    fi
+    echo -n '0'
+    if test "$i" -lt $(($ac_mtx_size - 1)); then
+        echo -n ','
+    fi
+    i=$(( i + 1 ))
+done
+
+cat <<'EOF'
+}}}
+##
+## Local Variables:
+## mode: c
+## buffer-read-only: t
+## End:
+##
+EOF
+
+exit 0